c
c tdc common
c
c the tdc is the time between the trigger and the first time
c sampling.  Therefore, the time associated to time slice i of a
c given cell for cubic fit timing is given by
c 
c t(ns) = (i - 1)*25 + tdc_ns
c
c tdc_raw         raw tdc value in tdc units for this event
c tdc_ns          wac corrected tdc values in ns for this event
c tdc_raw_to_ns   conversion factor from tdc to ns scales
c
c the following words is for experts only
c tdc_raw_shift   tdc shift (different wac trigger) for this event
c tdc_br_point    tdc wrap around constant for this event
c tdc_wac_c       wac_c for that run
c tdc_wac_epi     wac_epi for that run
c tdc_wac_mu      wac_mu for that run
c
c tdc_dubious     .true., if the current TDC value is inside TDC break-
c                  point region. It means that the value MAY be incorrect 
c                  by 25 nsec. It should be either checked and corrected 
c                  (if necessary) by user or the event should be rejected, 
c                  if such the check is impossible
c tdc_guard_region
c
c tdc_ns_shift       time slice shift to correct October 1997 tdc
c
      integer tdc_raw
      real tdc_ns
      real tdc_raw_to_ns
c
      integer tdc_raw_shift
      integer tdc_br_point
      integer tdc_wac_c, tdc_wac_epi, tdc_wac_mu
c
      real tdc_ns_shift
      logical tdc_dubious
      integer tdc_guard_region
      
      common /ssstdc/ tdc_raw, 
     +                tdc_ns, 
     +                tdc_raw_to_ns,
     +                tdc_raw_shift,
     +                tdc_br_point, 
     +                tdc_wac_c, 
     +                tdc_wac_epi, 
     +                tdc_wac_mu,
     +                tdc_dubious,
     +                tdc_guard_region,
     +                tdc_ns_shift
c 
