      subroutine hec_tdc_ini
c
c set the tdc wrap around constants for this run
c
      implicit none
c
      include'hec_par.inc'      ! parameter common
      include'hec_datacard.inc' ! datacard values
      include'hec_runh.inc'     ! run header
      include'hec_tdc.inc'      ! tdc value
c
c set conversion constant
c the number found September 1999 by Leonid, directly from hardware is
c 0.01782 ns/tdc.  But, Andrei and Michel find that this value does not 
c correspond to the best value to use offline, which is 0.01816 ns/tdc.
c
      tdc_raw_to_ns = 0.01816
c
c reset some variables
c
      tdc_ns = 0.
      tdc_raw_shift = 0
c
c for various run periods, set the tdc parameters
c
      if (irunpd .eq. 12) then ! Jun2000
c
c start with end of August 99 defaults
c
        tdc_guard_region = 10
        tdc_wac_c   = 1424
        tdc_wac_epi = 1416
        tdc_wac_mu  = 1410

      else if (irunpd .eq. 11) then ! Feb2000
c
c start with end of August 99 defaults
c
        tdc_guard_region = 10
        tdc_wac_c   = 1424
        tdc_wac_epi = 1416
        tdc_wac_mu  = 1410

      else if (irunpd .eq. 10) then ! aug99
c
c for August 1999, the tdc correction changes for run 8896
c
        tdc_guard_region = 10
        if (run_no .lt. 8896) then
          tdc_wac_c   = 1424
          tdc_wac_epi = 2104
          tdc_wac_mu  = 2310
        else
          tdc_wac_c   = 1424
          tdc_wac_epi = 1416
          tdc_wac_mu  = 1410
        endif
c
      elseif (irunpd .eq. 9) then ! jun99
c
c for June 1999, the tdc correction is run independent
c
        tdc_guard_region = 10
        tdc_wac_c   = 1424
        tdc_wac_epi = 2104
        tdc_wac_mu  = 2310
c
      elseif (irunpd .eq. 8) then ! aug98
c
c for August 1998, the tdc corrections changes for run 7871
c this is preliminary
c
        tdc_guard_region = 10
        if (run_no .lt. 7871) then
          tdc_wac_c   = 1560
          tdc_wac_epi = 1660
        else
          tdc_wac_c   = 1424
          tdc_wac_epi = 2104
        endif
        tdc_wac_mu  = 2320
c
c for April 1998, we believe the tdc corrections are run independent
c this is preliminary
c
      elseif (irunpd .eq. 7) then ! apr98
        tdc_guard_region = 10
        tdc_wac_c   = 1560
        tdc_wac_epi = 1660
        tdc_wac_mu  = 1884
c
      elseif (irunpd .eq. 6) then ! Oct97
        tdc_ns_shift  = 34.5
      endif
c
c print the values used
c
      if (irunpd .ge. 7) then 
        print *,' '
        print *, ' *** tdc wrap around constants used for run number ', 
     +  run_no, ' are'
        print *, '     wac_c         = ', tdc_wac_c
        print *, '     wac_epi       = ', tdc_wac_epi
        print *, '     wac_mu        = ', tdc_wac_mu
      endif
c
      end




 
